#include <stdio.h>
#include <stdint.h>

/* romc type 0 (no compression) */

int main(int argc, char ** argv)
{
    if (argc != 3)
    {
        fprintf(stderr, "usage: romc0 infile outfile\n");
        return 1;
    }

    FILE *infile = fopen(argv[1], "rb");
    if (!infile)
    {
        perror("error opening input");
        return 1;
    }
    FILE *outfile = fopen(argv[2], "wb");
    if (!outfile)
    {
        perror("error opening output");
        return 1;
    }


    if (-1 == fseek(infile, 0, SEEK_END))
    {
        perror("error seeking to end");
        return 1;
    }
    const uint32_t size = ftell(infile);
    if (-1 == fseek(infile, 0, SEEK_SET))
    {
        perror("error seeking to start");
        return;
    }

    {
        uint8_t head_buf[4];
        uint32_t sizeacc = size;
        head_buf[3] = ((sizeacc & 0x3f) << 2) | 0; // type 0, uncompressed
        sizeacc /= 0x40;
        head_buf[2] = sizeacc;
        sizeacc /= 0x100;
        head_buf[1] = sizeacc;
        sizeacc /= 0x100;
        head_buf[0] = sizeacc;
        if (1 != fwrite(head_buf, 4, 1, outfile))
        {
            perror("error writing header");
            return 1;
        }
    }

    /*
    uint32_t nominal_size;
    nominal_size = head_buf[0];
    nominal_size *= 0x100;
    nominal_size |= head_buf[1];
    nominal_size *= 0x100;
    nominal_size |= head_buf[2];
    nominal_size *= 0x40;
    nominal_size |= head_buf[3]>>2;
    romc_type = head_buf[3]&0x3;
    */

    uint8_t copy_buf[BUFSIZ];

    uint32_t sizecnt = size;
    for (;sizecnt >= sizeof(copy_buf);sizecnt-=sizeof(copy_buf))
    {
        if (1 != fread(copy_buf, sizeof(copy_buf), 1, infile))
        {
            perror("error reading for copy");
            return 1;
        }
        if (1 != fwrite(copy_buf, sizeof(copy_buf), 1, outfile))
        {
            perror("error writing for copy");
            return 1;
        }
    }

    if (sizecnt > 0)
    {
        if (1 != fread(copy_buf, sizecnt, 1, infile))
        {
            perror("error reading for copy");
            return 1;
        }
        if (1 != fwrite(copy_buf, sizecnt, 1, outfile))
        {
            perror("error writing for copy");
            return 1;
        }
    }

    if (EOF == fclose(outfile))
    {
        perror("error on fclose");
        return 1;
    }
    fclose(infile);

    return 0;
}
